zoukankan      html  css  js  c++  java
  • [LeetCode] 568. Maximum Vacation Days 最大化休假日

    LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

    Rules and restrictions:

    1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
    2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
    3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
    4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

    You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

    Example 1:

    Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
    Output: 12
    Explanation: 
    Ans = 6 + 3 + 3 = 12.
    One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
    (Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

    Example 2:

    Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
    Output: 3
    Explanation: 
    Ans = 1 + 1 + 1 = 3.
    Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
    For each week, you only have one day to play and six days to work.
    So the maximum number of vacation days is 3.

    Example 3:

    Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
    Output: 21
    Explanation:
    Ans = 7 + 7 + 7 = 21
    One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

    Note:

    1. N and K are positive integers, which are in the range of [1, 100].
    2. In the matrix flights, all the values are integers in the range of [0, 1].
    3. In the matrix days, all the values are integers in the range [0, 7].
    4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
    5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
    6. We don't consider the impact of flight hours towards the calculation of vacation days.

    flights是n*n矩阵, 表示city之间是否能飞; days[i][j] 是n*k矩阵,表示在city i,week j 这个时间最多能玩几天。初始是在city 0, 问最多能玩几天。注意的是第一周不一定非得在city 0, 可以当天飞到其他city开始。
    解法1:DFS, 对每一个当前city,遍历所有它能到达的城市,返回当前week在cur_city能得到的最大值,days[i][week] + dfs(flights, days, i, week+1, data),通过打表data来保存中间值,不然会超时。

    解法2:DP, 用dp[i][j]来表示 week i in city j, 最多可以得到多少个vacation。dp[i][j] = max(dp[i - 1][k] + days[j][i]) (k = 0...N - 1, if we can go from city k to city j)

    Java: DFS

    public class Solution {
        int max = 0, N = 0, K = 0;
        
        public int maxVacationDays(int[][] flights, int[][] days) {
            N = flights.length;
            K = days[0].length;
            dfs(flights, days, 0, 0, 0);
            
            return max;
        }
        
        //curr: current city
        private void dfs(int[][] f, int[][] d, int curr, int week, int sum) {
            if (week == K) {
                max = Math.max(max, sum);
                return;
            }
            
            for (int dest = 0; dest < N; dest++) {
                if (curr == dest || f[curr][dest] == 1) {
                    dfs(f, d, dest, week + 1, sum + d[dest][week]);
                }
            }
        }
    }
    

    Java: DP

    public class Solution {
        public int maxVacationDays(int[][] flights, int[][] days) {
            int N = flights.length;
            int K = days[0].length;
            int[] dp = new int[N];
            Arrays.fill(dp, Integer.MIN_VALUE);
            dp[0] = 0;
            
            for (int i = 0; i < K; i++) {
                int[] temp = new int[N];
                Arrays.fill(temp, Integer.MIN_VALUE);
                for (int j = 0; j < N; j++) {
                    for(int k = 0; k < N; k++) {
                        if (j == k || flights[k][j] == 1) {
                            temp[j] = Math.max(temp[j], dp[k] + days[j][i]);
                        }
                    }
                }
                dp = temp;
            }
            
            int max = 0;
            for (int v : dp) {
                max = Math.max(max, v);
            }
            
            return max;
        }
    }
    

    Java: DP  

    public int maxVacationDays(int[][] flights, int[][] days) {
            int N = flights.length, K = days[0].length; 
            int[] dp = new int[N];
            for (int i=K-1;i>=0;i--) {
                int[] temp = new int[N];
                for (int j=0;j<N;j++) {
                    temp[j] = days[j][i];
                    int max = dp[j];
                    for (int n=0;n<N;n++) 
                        if (flights[j][n] == 1) max = Math.max(max, dp[n]);
                    temp[j] += max;
                }
                dp = temp;
            }
    
            int max = dp[0];
            for (int i=0;i<N;i++) 
                if (flights[0][i] == 1) max = Math.max(max, dp[i]);
            return max;
        }   

    Python:

    # Time:  O(n^2 * k)
    # Space: O(k)
    class Solution(object):
        def maxVacationDays(self, flights, days):
            """
            :type flights: List[List[int]]
            :type days: List[List[int]]
            :rtype: int
            """
            if not days or not flights:
                return 0
            dp = [[0] * len(days) for _ in xrange(2)]
            for week in reversed(xrange(len(days[0]))):
                for cur_city in xrange(len(days)):
                    dp[week % 2][cur_city] = days[cur_city][week] + dp[(week+1) % 2][cur_city]
                    for dest_city in xrange(len(days)):
                        if flights[cur_city][dest_city] == 1:
                            dp[week % 2][cur_city] = max(dp[week % 2][cur_city], 
                                                         days[dest_city][week] + dp[(week+1) % 2][dest_city])
            return dp[0][0]  

    C++:

    // Time:  O(n^2 * k)
    // Space: O(k)
    class Solution {
    public:
        int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
            if (days.empty() || flights.empty()) {
                return 0;
            }
            vector<vector<int>> dp(2, vector<int>(days.size()));
            for (int week = days[0].size() - 1; week >= 0; --week) {
                for (int cur_city = 0; cur_city < days.size(); ++cur_city) {
                    dp[week % 2][cur_city] = days[cur_city][week] + dp[(week + 1) % 2][cur_city];
                    for (int dest_city = 0; dest_city < days.size(); ++dest_city) {
                        if (flights[cur_city][dest_city] == 1) {
                            dp[week % 2][cur_city] = max(dp[week % 2][cur_city],
                                                         days[dest_city][week] + dp[(week + 1) % 2][dest_city]);
                        }
                    }
                }
            }
            return dp[0][0];
        }
    };  

    C++:

    class Solution {
    public:
        int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
            int n = flights.size(), k = days[0].size(), res = 0;
            vector<vector<int>> dp(n, vector<int>(k, 0));
            for (int j = k - 1; j >= 0; --j) {
                for (int i = 0; i < n; ++i) {
                    dp[i][j] = days[i][j];
                    for (int p = 0; p < n; ++p) {
                        if ((i == p || flights[i][p]) && j < k - 1) {
                            dp[i][j] = max(dp[i][j], dp[p][j + 1] + days[i][j]);
                        }
                        if (j == 0 && (i == 0 || flights[0][i])) res = max(res, dp[i][0]);
                    }
                }
            }
            return res;
        }
    };
    

    C++:

    class Solution {
    public:
        int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
            int n = flights.size(), k = days[0].size();
            vector<int> dp(n, INT_MIN);
            dp[0] = 0;
            for (int j = 0; j < k; ++j) {
                vector<int> t(n, INT_MIN);
                for (int i = 0; i < n; ++i) {
                    for (int p = 0; p < n; ++p) {
                        if (i == p || flights[p][i]) {
                            t[i] = max(t[i], dp[p] + days[i][j]);
                        }
                    }
                }
                dp = t;
            }
            return *max_element(dp.begin(), dp.end());
        }
    };
    

      

      

    All LeetCode Questions List 题目汇总

  • 相关阅读:
    css引入讲解及media
    css中的media
    IE6存在的一些兼容
    Eclipse 反编译插件JadClipse安装
    JavaScript 常用功能总结
    241个jquery插件—jquery插件大全
    javascript深入理解js闭包
    JS拖拽插件实现步骤
    JavaScript拖拽原理的实现
    js实现拖拽效果
  • 原文地址:https://www.cnblogs.com/lightwindy/p/9618370.html
Copyright © 2011-2022 走看看